﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Web;

namespace KuaiDiChaXun
{
    /// <summary>
    /// 快递查询处理类
    /// </summary>
    public class KuaiDiChaXunBLL
    {
        #region 固定参数，实际项目中可写在配置文件中，方便修改
        string url = "https://api.kdniao.com/Ebusiness/EbusinessOrderHandle.aspx";//请求url，正式环境
        string eBusinessID = "1257157";//用户ID，此ID仅作演示使用，实际调用需换成自己的ID，登录快递鸟官网会员中心获取 ，
        string apiKey = "F201358A-513B-4237-98D6-67DE7EA75BA3";//用户秘钥，此秘钥仅作演示使用，实际调用需换成自己的秘钥，登录快递鸟官网会员中心获取 https://www.kdniao.com/UserCenter/v4/UserHome.aspx?from=wzh
        /*了解更多产品及功能请前往快递鸟官网查看：https://kdniao.com/products?from=wzh
        * 对接技术文档资料登录快递鸟文档专区查看：https://kdniao.com/documents?from=wzh
        * 如无EBusinessID和ApiKey可前往快递鸟注册中心：https://kdniao.com/reg?from=wzh 注册后在快递鸟会员中心获取*/
        #endregion

        /// <summary>
        /// 查询快递路由轨迹
        /// </summary>
        /// <param name="shipperCode">快递公司编码</param>
        /// <param name="waybillCode">运单号</param>
        /// <param name="phoneNo">收/寄件人手机号后4位，SF必填</param>
        /// <returns></returns>
        public string SearchRoute(string shipperCode, string waybillCode, string phoneNo)
        {
            if (string.IsNullOrEmpty(shipperCode))
            {
                return "请输入快递公司编码";
            }
            if (string.IsNullOrEmpty(waybillCode))
            {
                return "请输入运单号";
            }
            if (string.IsNullOrEmpty(phoneNo) && shipperCode == "SF")
            {
                return "SF必填收/寄件人手机号后4位";
            }
            string result = string.Empty;
            //组装应用级参数，此Demo使用最少参数，更多参数参考技术文档
            string requestData = "{'ShipperCode':'" + shipperCode + "','LogisticCode':'" + waybillCode + "'}";
            if (shipperCode == "SF")//顺丰需收/寄件人手机号后4位
            {
                requestData = "{'ShipperCode':'" + shipperCode + "','LogisticCode':'" + waybillCode + "','CustomerName':'" + phoneNo + "'}";
            }
            //把(jsonStr+APIKey)进行MD5加密
            string md5Str = MD5(requestData + apiKey, "UTF-8");
            //把md5Str 进行Base64编码
            string base64Str = base64(md5Str, "UTF-8");
            //进行URL编码 (utf-8),最终得到签名串
            string dataSign = HttpUtility.UrlEncode(base64Str, Encoding.UTF8);
            //请求接口指令
            string cmd = "8001";
            //组装系统级参数
            string postData = "RequestData=" + HttpUtility.UrlEncode(requestData, Encoding.UTF8) + "&EBusinessID=" + eBusinessID + "&RequestType="+ cmd + "&DataSign=" + dataSign + "&DataType=2";
            //发起请求
            HttpHelper helper = new HttpHelper();
            HttpRequestEntity response = helper.Request(url, postData);
            if (response.IsSuccess == 0)
            {
                result = response.ResponseContent;
                //拿到结果后进行后续业务操作
            }
            else
            {
                result = "请求异常";
                //记录错误信息及后续业务补偿
            }
            return result;
        }

        ///<summary>
        /// 字符串MD5加密
        ///</summary>
        ///<param name="str">要加密的字符串</param>
        ///<param name="charset">编码方式</param>
        ///<returns>密文</returns>
        public string MD5(string str, string charset)
        {
            byte[] buffer = Encoding.GetEncoding(charset).GetBytes(str);
            try
            {
                System.Security.Cryptography.MD5CryptoServiceProvider check;
                check = new System.Security.Cryptography.MD5CryptoServiceProvider();
                byte[] somme = check.ComputeHash(buffer);
                string ret = "";
                foreach (byte a in somme)
                {
                    if (a < 16)
                        ret += "0" + a.ToString("X");
                    else
                        ret += a.ToString("X");
                }
                return ret.ToLower();
            }
            catch
            {
                throw;
            }
        }

        /// <summary>
        /// base64编码
        /// </summary>
        /// <param name="str">内容</param>
        /// <param name="charset">编码方式</param>
        /// <returns></returns>
        public string base64(string str, string charset)
        {
            return Convert.ToBase64String(Encoding.GetEncoding(charset).GetBytes(str));
        }
    }
}
